
#include <string>
#include <iostream>

using namespace std;

#include "Scheduler.h"
#include "Handler.h"
#include "Event.h"
#include "Agent.h"
#include "Packet.h"
#include "Event.h"

class AgentPing : public Agent {
public:
	AgentPing( const char name[] ) : name_( name ) {
	}
	
	virtual void recv( Packet * packet ) {
		printf( "Handle: %.1f: %s\n", packet -> getTime(), name_.c_str() );
		delete( packet );
		if ( packet -> getTime() > 3.0 )
			return;
		packet = new Packet();
		sendInChannel( 0, packet );
	}
	
protected:
	string name_;
};

int main() {

	AgentPing * agent_A = new AgentPing( "Ping" );
	AgentPing * agent_B = new AgentPing( "Pong" );

	agent_A -> addChannel( agent_B, 0.2 );
	agent_B -> addChannel( agent_A, 0.1 );
	
	Packet * bounce = new Packet();
	agent_A -> sendInChannel( 0, bounce );

	while ( Scheduler::instance().dispatch() );
	
	Scheduler::instance().flush();
	
	delete( agent_A );
	delete( agent_B );
	
	return 0;
}
